/*
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA  02110-1301, US$

    Copyright (C) 2009 Jeroen van Beek <jeroen@dexlab.nl>
*/
//---------------------------------------------------------------------------
#pragma hdrstop
#include <vcl.h>
#include <tchar.h>
#include "main.h"
#include "crypto1.h"
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMain *FormMain;
AnsiString build = "20090611";
//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner) : TForm(Owner)
{
	LabelBuild->Caption = "build " + build;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonCrackKetClick(TObject *Sender)
{
	EditKey->Text = "?";
	EditUid->Text = StringReplace((StringReplace(EditUid->Text, " ", "", TReplaceFlags() << rfReplaceAll)), "!", "", TReplaceFlags() << rfReplaceAll).Trim().UpperCase();
	EditTagChallenge->Text = StringReplace((StringReplace(EditTagChallenge->Text, " ", "", TReplaceFlags() << rfReplaceAll)), "!", "", TReplaceFlags() << rfReplaceAll).Trim().UpperCase();
	EditReaderChallenge->Text = StringReplace((StringReplace(EditReaderChallenge->Text, " ", "", TReplaceFlags() << rfReplaceAll)), "!", "", TReplaceFlags() << rfReplaceAll).Trim().UpperCase();
	EditReaderResponse->Text = StringReplace((StringReplace(EditReaderResponse->Text, " ", "", TReplaceFlags() << rfReplaceAll)), "!", "", TReplaceFlags() << rfReplaceAll).Trim().UpperCase();
	EditTagResponse->Text = StringReplace((StringReplace(EditTagResponse->Text, " ", "", TReplaceFlags() << rfReplaceAll)), "!", "", TReplaceFlags() << rfReplaceAll).Trim().UpperCase();

	bool error = false;
	AnsiString msg = "";
	if(EditUid->Text.Length() != 8)
	{
		msg = LabelUid->Caption;
		error = true;
	}
	else if(EditTagChallenge->Text.Length() != 8)
	{
		msg = LabelTagChallenge->Caption;
		error = true;
	}
	else if(EditReaderChallenge->Text.Length() != 8)
	{
		msg = LabelReaderChallenge->Caption;
		error = true;
	}
	else if(EditTagResponse->Text.Length() != 8)
	{
		msg = LabelTagResponse->Caption;
		error = true;
	}
	else if(EditReaderResponse->Text.Length() != 8)
	{
		msg = LabelReaderChallenge->Caption;
		error = true;
	}
	if(error)
	{
		Application->MessageBox(AnsiTowchar_t("Length of input field \"" + msg + "\" must be 8, aborted."), AnsiTowchar_t("Wrong input length"), MB_ICONERROR);
		return;
	}
	EditKey->Text = "cracking...";

	struct Crypto1State *revstate;
	uint64_t lfsr;
	unsigned char* plfsr = (unsigned char*)&lfsr;

	unsigned int uid = httoi(EditUid->Text.c_str());
	unsigned int tag_challenge = httoi(EditTagChallenge->Text.c_str());
	unsigned int nr_enc = httoi(EditReaderChallenge->Text.c_str());
	unsigned int reader_response = httoi(EditReaderResponse->Text.c_str());
	unsigned int tag_response = httoi(EditTagResponse->Text.c_str());
	unsigned int ks2 = reader_response ^ prng_successor(tag_challenge, 64);
	unsigned int ks3 = tag_response ^ prng_successor(tag_challenge, 96);

	revstate = lfsr_recovery(ks2, ks3);
	lfsr_rollback(revstate, 0, 0);
	lfsr_rollback(revstate, 0, 0);
	lfsr_rollback(revstate, nr_enc, 1);
	lfsr_rollback(revstate, uid ^ tag_challenge, 0);
	crypto1_get_lfsr(revstate, &lfsr);

	AnsiString key = IntToHex((__int64)plfsr[0], 2) + IntToHex((__int64)plfsr[1], 2) + IntToHex((__int64)plfsr[2], 2) +  IntToHex((__int64)plfsr[3], 2) +  IntToHex((__int64)plfsr[4], 2) +  IntToHex((__int64)plfsr[5], 2);
	EditKey->Text = key.UpperCase();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonExitClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonClearClick(TObject *Sender)
{
	EditUid->Text = "";
	EditTagChallenge->Text = "";
	EditReaderChallenge->Text = "";
	EditTagResponse->Text = "";
	EditReaderResponse->Text = "";
	EditKey->Text = "?";
}
//---------------------------------------------------------------------------
int __fastcall TFormMain::httoi(const TCHAR *value)
{
  struct CHexMap
  {
	TCHAR chr;
	int value;
  };
  const int HexMapL = 16;
  CHexMap HexMap[HexMapL] =
  {
	{'0', 0}, {'1', 1},
	{'2', 2}, {'3', 3},
	{'4', 4}, {'5', 5},
	{'6', 6}, {'7', 7},
	{'8', 8}, {'9', 9},
	{'A', 10}, {'B', 11},
	{'C', 12}, {'D', 13},
	{'E', 14}, {'F', 15}
  };
  TCHAR *mstr = _tcsupr(_tcsdup(value));
  TCHAR *s = mstr;
  int result = 0;
  if (*s == '0' && *(s + 1) == 'X') s += 2;
  bool firsttime = true;
  while (*s != '\0')
  {
	bool found = false;
	for (int i = 0; i < HexMapL; i++)
	{
	  if (*s == HexMap[i].chr)
	  {
		if (!firsttime) result <<= 4;
		result |= HexMap[i].value;
		found = true;
		break;
	  }
	}
	if (!found) break;
	s++;
	firsttime = false;
  }
  free(mstr);
  return result;
}
//---------------------------------------------------------------------------
wchar_t* __fastcall TFormMain::AnsiTowchar_t(AnsiString Str)
{
  wchar_t *str = new wchar_t[Str.WideCharBufSize()];
  return Str.WideChar(str, Str.WideCharBufSize());
}
//---------------------------------------------------------------------------

